/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

char *opt_name (name)  /* $name_opt */
char *name;
{
	char *str;
	char *tname;
	T_Entry *entry;

	if ((entry = lookup_all (name)) == TN)
		SYSERR;

	tname = entry->orig_name;

	str = (char*) U_malloc (strlen (tname) + 1 + 4 + 1);
	strcpy (str, "$");
	strcat (str, tname);
	strcat (str, "_opt");

	return str;
}

opt_decl ()  /* declares extra variables to deal with optional arguments */
{
	int first = 1;
	T_Entry *entry;

	for_TABLE_LOOP (entry)
		if (IS_optional (entry))
			if (first) {
				first = 0;
				otab ();
				oLOGICAL ();
				onam (opt_name (entry->orig_name));
			}
			else {
				ochb (',');
				onam (opt_name (entry->orig_name));
			}

	if (first == 0)
		odon ();
}

Node *opt_fill_opt (funname, funentry, sublist)
char *funname;
T_Entry *funentry;
Node *sublist;
{
	Node *sub, *temp, *new, *extra;
	Interf *interf = (Interf*) 0;
	T_Entry *entry;
	int acttype, dumtype;

	if (funentry == TN || sublist == NN)
		return sublist;

	if (IS_over (funentry))
		funentry = funentry->over->entry[0];
	
	if ((interf = funentry->interf) != (Interf*) 0
	&& IS_explicit (funentry)) {
		int i, num, nargs = interf->nargs;
		Node **args = (Node**) U_malloc (sizeof (Node*) * nargs), *newlist;
		char *argname;

		num = 1;
		for (LIST_LOOP (sub, sublist, temp)) {
			if (nargs <= num) {
					sprintf (serr
					, "procedure '%s' expects at most %d argument%s"
					, funname, interf->nargs - 1, error_s (interf->nargs - 1));
					fatal (serr);
					break;
			}

			if (sub->Subscript.Eq != NN) {  /* is keyword argument */
				argname = sub->Subscript.Name->com.str;

				sub->Subscript.Name = sub->Subscript.Eq = NN;
				for (i = 1; i < nargs; i++)
					if (!U_strcmp_nocase (argname, interf->args[i])) {
						if (args [i] != NN) {
							sprintf (serr
							, "redefinition of argument %d for procedure '%s'"
							, i, funname);
							fatal (serr);
						}
						else {
							args[i] = sub;
						}
						goto next;
					}

				sprintf (serr, "procedure '%s' doesn't have a dummy argument called '%s'"
				             , funname, argname);
				fatal (serr);
			}
			else {
				if (args [num] != NN) {
					sprintf (serr
					, "argument %d for procedure '%s' was previously set with a keyword argument"
					, num, funname);
					fatal (serr);
				}
				else {
					args[num] = sub;
				}
			}
next:
			num++;
		}

		for (i = 1; i < nargs; i++)  /* checks out missing arguments */
			if (args[i] == (Node*) 0 && !IS_optional (interf->entry[i])) {
				sprintf (serr, "argument %d of procedure '%s' is not an optional argument"				             , i, funname);
				fatal (serr);
			}

		sublist = make_List (&args[1], nargs - 1, SUBSCRIPT_LIST);
	}

	return sublist;
}

opt_end ()  /* instales extra variables in the symbol table for optional arguments */
{
	T_Entry *entry, *new_entry;

	for_TABLE_LOOP (entry)
		if (IS_optional (entry)) {
			new_entry = install_loc (opt_name (entry->orig_name), TAB_NAME, 0);
			new_entry->typ = typ_malloc ();
			new_entry->typ->etype = Etype_LOGICAL_0;
			SET_temporary (new_entry);
		}
}

